//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPoseSaveButton extends MSBListButton;

var string saveName;
var MSBPoseEditor Parent;

event PostBeginPlay()
{
local int i;
super.PostBeginPlay();

ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonText";
for (i=0;i<M.SavePoses.length+1;i++)
  ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonText";
}


function initButton(Canvas C)
{
super.initButton(C);

C.SetPos(xPos,yPos);
C.FontScaleX=buttonFontScale;
C.FontScaleY=buttonFontScale;
C.SetDrawColor(textCol.R,textCol.G,textCol.B);
C.DrawText(BtnName);
C.SetDrawColor(col.R,col.G,col.B);
C.FontScaleX=fontScale/1024 * C.ClipX;
C.FontScaleY=fontScale/1024 * C.ClipX;
}

function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i;
super.LeftBtn(C);
Parent.ListButton[5].deSelect();

for (i=currentpage*8;i<maxButtons;i++)
  {
    MSBPropertyButton(ListButton[i]).Property="saveName";
    MSBPropertyButton(ListButton[i]).Parent=self;
    MSBPropertyButton(ListButton[i]).BtnName="createNew";
    if (i<ButtonList.length-1)
      MSBPropertyButton(ListButton[i]).BtnName=M.SavePoses[i];
  }
}

event Trigger(Actor Other, Pawn EventInstigator)
{
local int i;
local MSBAniKey A;
Log("saving Pose!");

//todo: ??
for(i=0;i<Parent.lastbone;i++);
  MSBPawn(Parent.PoseActor).PoseKey[i]=None;

for (i=0;i<Parent.lastbone;i++)
  {
  A=Level.Game.CreateDataObject(class'MSBAniKey',savename$"Key"$i,"MovieSandboxPoses");
  A.BoneRotation=Parent.Pose.PoseKey[i].BoneRotation;
  }
Level.Game.SavePackage("MovieSandboxPoses");

//update SavePose List
for (i=0;i<ListButton.Length;i++)
  if (Other==ListButton[i] && i< ListButton.Length)
    M.SavePoses[i]=saveName;

M.SaveGeneralConfig();
}


DefaultProperties
{
width=64
height=12
BtnName="SavePose"
tooltip="Save the Pose"
}
