//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonRotateRelative extends MSBPropertyButton;
var bool bDragged;

var float xDist,
          yDist,
          oldX,
          oldY;

var rotator chgRot;

var bool bShift;

var EPhysics OldPhysics;

function InitButton(Canvas C)
{
if (bDragged)
  {

//  yPos=Mouse.yPos+yDist;
//  xPos=Mouse.xPos+xDist;

  if (bShift)
    chgRot.Roll=100*(Mouse.xPos-oldx);
  else
     {
     chgRot.Yaw=100*(Mouse.xPos-oldX);
     chgRot.Pitch=100*(Mouse.yPos-oldY);
     }

  Mouse.xPos=oldX;
  Mouse.yPos=oldY;

  Parent.SetRelativeRotation(Parent.RelativeRotation+chgRot);
  }
super.initButton(C);
}


function Render(Canvas C)
{
super.Render(C);
if (bEnabled)
 {
 if (hasClicked && Mouse.btnOne)
    {
    hasClickedAgain=true;
    LeftBtnFinished(C);
    hasClickedAgain=false;
    }
 if (hasClicked && Mouse.bShiftDown && !bShift)
    PressShift(C);
 }
if (!Mouse.bShiftDown)
 bShift=false;
}

function PressShift(Canvas C)
{
bShift=true;
}


function LeftBtn(Canvas C)
{
super.LeftBtn(C);
bDragged=true;
Mouse.bHitActors=false;

OldPhysics=Parent.Physics;
Parent.SetPhysics(PHYS_None);
oldX=Mouse.xPos;
oldY=Mouse.yPos;

}

function LeftBtnFinished(Canvas C)
{
local int i;
local MSBNodeButton N;

HasClicked=false;
//enable all other buttons after second press
for (i=0;i<M.myHud.Overlays.Length-1;i++)
  if (M.myHud.Overlays[i].IsA('MSBGuiOverlay'))
    MSBGuiOverlay(M.myHud.Overlays[i]).bEnabled=true;

Mouse.btnOne=false;
bDragged=false;

//if we move a Pawn, then set InitialRotation in depending MSBRootNode
Parent.SetPhysics(OldPhysics);
if (Parent.IsA('Pawn'))
  {
  foreach AllActors(class'MSBNodeButton',N)
    if (MSBRootNode(N.Order).BasePawn==Pawn(Parent))
       MSBRootNode(N.Order).initialRotation=Parent.Rotation;
   }

if (Parent.IsA('MSBSpritePawn'))
  {
  foreach AllActors(class'MSBNodeButton',N)
    if (MSBSpriteNode(N.Order).BasePawn==MSBSpritePawn(Parent))
      MSBSpriteNode(N.Order).initialRotation=Parent.Rotation;
  }

if (Parent.IsA('MSBCamera'))
  MSBCamera(Parent).initialRotation=Parent.Rotation;

Mouse.bHitActors=true;
}

DefaultProperties
{
BtnName="RotateRel"
}
